// ======================================================================
//
// MenuButton.h
// jeff grills
//
// copyright 1997 origin systems inc
//
// ======================================================================

#ifndef MENU_BUTTON_H
#define MENU_BUTTON_H

// ======================================================================

#include "MenuElement.h"
#include "MenuResource.h"

// ======================================================================

class MenuButton : public MenuElement
{
protected:

	enum
	{
		left,
		right,
		buttons
	};

	enum
	{
		press,
		release,
		click,
		actions
	};

	struct Event
	{
		int button;
		int type;
		int event;
	};

protected:

	static Timer       clickTimer;
	static int         clickTimerButton;
	static MenuButton *clickTimerOwner;

protected:

	Event *events;
	int   numEvents;

protected:
	
	static bool isValidButton(int button);

private:

	MenuButton(void);
	MenuButton(const MenuButton &);
	MenuButton &operator =(const MenuButton &);
	void             init(void);

public:

	MenuButton(MenuElement *parent, int maxWidth, int maxHeight, Iff *iff=NULL);
	virtual ~MenuButton(void);

	void             load(Iff *iff);

	// IoWin routines
	virtual IoResult event(IoEventStruct *event);
};

class MenuToggle : public MenuButton
{
protected:

	MenuResourceInteger menuResourceInteger;

private:

	MenuToggle(void);
	MenuToggle(const MenuToggle &);
	MenuToggle &operator =(const MenuToggle &);

public:

	MenuToggle(MenuElement *parent, int maxWidth, int maxHeight, Iff *iff=NULL);
	virtual ~MenuToggle(void);

	void load(Iff *iff);

	virtual MenuResourceInteger *getMenuResourceInteger(void);

	virtual void menuDraw(int x, int y) const;
	virtual void menuEvent(int id, MenuElement *whom);
};

// ======================================================================

inline bool MenuButton::isValidButton(int button)
{
	return (button == left || button == right);
}

// ======================================================================

#endif
